/**
 * Plugin to render mathematics formula embedded in grid content.
 * The processing is performed by MathJax.
 * The MathJax library is loaded by the framework
 * 
 * @version $Id$
 *
 */

Ext.namespace('App.grid');
 
App.grid.MathJax = Ext.extend(Object, {

    init: function (grid) {

        function processMath() {
            MathJax.Hub.PreProcess();
            MathJax.Hub.Process();            
        }
        
        // NOTE: in some case mathJax error appears on the first rendering
        // Adding a delay of 0.1 s seems to fixed this problem
        grid.getView().on('refresh', processMath, grid, {delay: 100});
        
    }
});
    
Ext.preg('pGridMathJax', App.grid.MathJax);