/**
 * store_1.js
 *
 * To test and debug JsonStore using Ext.data.DirectStore protocole.
 * Example can be found here: http://extdirectspring.ralscha.ch/demo/
 * 
 * $Id$
 *
 */
Ext.namespace('Dev.data');

/**
 * main function
 */

function main (provider, response){

    if (response instanceof String) {
        Ext.Msg.alert('ERROR', response);
        return;
    }

    if (response.type === 'exception') {
        Ext.Msg.alert('ERROR', response.xhr.statusText);        
        return;
    }

	var cfg = response.result;
	
	console.log('JsonStore configuration');
//	console.dir(cfg);

    var myApi = {
        create: Dbui.create,
        destroy: Dbui.destroy,
        read: Dbui.read,
        update: Dbui.update
    };
        
    cfg = Ext.apply(cfg, {api: myApi});
    
	var store = new App.data.DirectStore(cfg);
	
//	store.load();

	/* 
	 * play with the store when loaded
	 * Un-comment block of lines to test:
	 * update, add or destroy functionalities
	 * 
	 */
	
//	store.on("load", function () {
//		console.log("store loaded: "+this.getCount()+" records")
	
        // get a record
//        var record = this.getAt(1);
//        console.log('get a record at 1');
//        console.dir(record);
        
		// update the record
//        var record = this.getAt(1);
//        console.log('update record');
//		record.set("CountriesAbbreviation", "yy");
//		this.save();

		// Add a new record
//        console.log('create a new record');
//		var record = new this.recordType();
//		record.set("CountriesCountry", "Japan");
//        record.set("CountriesAbbreviation", "FR");
//		this.add(record);
//		this.insert(0, record);
//		this.save();
		
		// Delete a record
//		var record = this.getAt(this.find("CountriesCountry", "Japan"));
//		console.log("records to be delete");
//		console.dir(record);
//		this.remove(record);
//		this.save();
		
//	}, store);
	
//    Dbui.getGrid(store.baseParams.tableName, mainGrid);
};

function mainGrid(provider, response){

    if (response instanceof String) {
        Ext.Msg.alert('ERROR', response);
        return;
    }
    
    if (response.type === 'exception') {
        Ext.Msg.alert('ERROR', response.xhr.statusText);
        return;
    }
    
    var cfg = response.result;
    
    delete cfg.formModel;
    delete cfg.plugins;
    
    cfg.iconCls = 'silk-grid';
//    cfg.frame = false;
    cfg.viewConfig = {forceFit: true};

    console.log('Grid configuration');
    console.dir(cfg);

    var grid = Ext.ComponentMgr.create(cfg);
    
    console.log('grid object');
    console.dir(grid);
        
    var vp = new Ext.Viewport({
        region: 'center',
        layout: 'fit',
        items: [grid],
    });

}

Ext.onReady(function () {

    Ext.QuickTips.init();
	Ext.Direct.addProvider(App.REMOTE_API);

//    console.log('REMOTE_API');
//    console.dir(App.REMOTE_API);
    
//	Dbui.getJsonStore('countries', main);
//    Dbui.getJsonStore('projects', main);
    Dbui.getJsonStore('publications', main);

});